<?php
// hide nopro-lib (js)-scripts
//
// 2014-03-21 allow https by using _SERVER['REQUEST_SCHEME']

if(isset($_SERVER['HTTP_HOST']) && !isset($_GET['init'])) {
  
  // for browsers which dont send http_referer (f.e. opera)
  if(isset($_SERVER['HTTP_REFERER']))
    $oref = $_SERVER['HTTP_REFERER'];
  else if(isset($_COOKIE['oref']))
    $oref = $_COOKIE['oref'];
  else {
    header('Content-Type: application/javascript');
    //die('alert("enable Cookies\n"+document.cookie);');
    die('location.reload();');
  }
}

if(!defined('CRLF')) define('CRLF', PHP_EOL);
define('DBGverbous', false);

require('dhkey.php');
require('nopro_parse_js.php');

if(isset($_GET['lib'])) {
  
  if(isset($_GET['cid0']) && isset($_GET['cid2'])) {
    $cid0 = $_GET['cid0'];
    $cid2 = $_GET['cid2'];
  } else if(isset($_COOKIE['cid0']) && isset($_COOKIE['cid2'])) {
    $cid0 = $_COOKIE['cid0'];
    $cid2 = $_COOKIE['cid2'];
    setcookie("cid0", "", time()-3600);
    setcookie("cid2", "", time()-3600);
  } else {
    require('_spy.php'); exit;
  }
  nplrequest($_GET['lib'], $cid0, $cid2);
  exit;
  
} else if(isset($_GET['js'])) {

  if(isset($_SERVER['HTTP_USER_AGENT']) && strpos($_SERVER['HTTP_USER_AGENT'], 'Konqueror') > 0) {
      $req = $_GET['js'];
      goto konq;
    }
  
  $base = $_SERVER['REQUEST_SCHEME'] .'://'. $_SERVER['HTTP_HOST'];
  #$base = 'http://'. $_SERVER['HTTP_HOST'];
  
  $p1 = strlen($base);
  $p2 = strrpos($oref, '/');
  $myurl = $base . $_SERVER['SCRIPT_NAME'];
  $jsurl = substr($oref, $p1+1, $p2-$p1) . $_GET['js'];
  $requrl = $myurl .'?lib='. $jsurl;
  
  header('Content-Type: application/javascript');
  //echo "alert('nplreq $requrl');";
  die('$(document).ready(function() {nplreq("'. $requrl .'");});');
  
} else if(isset($_GET['init'])) { // set dhp-cookie via JS
  
  header('Content-Type: application/javascript');
  echo 'var t=new Date().getTime(),e=new Date(t+300000).toUTCString();' .CRLF; 	// 300 sec
  printf('document.cookie="dhpub=%s.%s;expires="+e;' .CRLF, $dh_gs, $dh_qs3 );
  echo   'document.cookie="oref="+location.href+";expires="+e;' .CRLF;
  #echo 'alert("cookies: "+document.cookie);';
  echo CRLF;
  
  $roots = array(
		 array(1, 'js/bigint.js'),
		 array(1, 'js/base64.js'),
		 array(1, 'js/js-mcrypt/rijndael.js'),
		 array(1, 'js/js-mcrypt/mcrypt.js'),
		 array(1, 'js/liblock.js')
		 );
  
  foreach($roots as $r) {
    list($c, $f) = $r;
    if($c == 1) {
      $pjs = new jsparser(__DIR__.'/'. $f, true);
      echo $pjs->text_full() .CRLF;	// crlf is very important here
    }
    else if($c == 2) {
      $pjs = new jsparser(__DIR__.'/'. $f, true);
      echo $pjs->text_4dbg() .CRLF;
    }
    else {
      readfile(__DIR__.'/'. $f);
    }
  }
  
  exit;
} else if(isset($_GET['dbg'])) {

  $req = $_GET['dbg'];
konq:
  
  $base = $_SERVER['REQUEST_SCHEME'] .'://'. $_SERVER['HTTP_HOST'];
  #$base = 'http://'. $_SERVER['HTTP_HOST'];
  $p1 = strlen($base);
  $p2 = strrpos($oref, '/');
  $fnam = $_SERVER['DOCUMENT_ROOT'] . substr($oref, $p1, 1+$p2-$p1) . $req;
  
  header('Content-Type: application/javascript');
  //header('Content-Length: '.filesize($fnam)); readfile($fnam);
  
  $pjs = new jsparser($fnam, true);
  if(isset($_GET['long'])) {
    echo $pjs->text_4dbg();
  } else {
    echo $pjs->text_full();
  }

  exit;
}

function nplrequest($jsname, $cid0, $cid2) {
  
  if(!extension_loaded('gmp')) {
      header('HTTP/1.1 500 No gmp-support');
      die("php-module gmp is not loaded");
  }

  $xploit = strstr($jsname, '..');
  if(!$xploit)
    $xploit = preg_match("/[ <|>&!]|\.(cgi|php|pl|sh)$|(^|\/)(\.|index\.)/", $jsname);
  if(!$xploit)
    $xploit = !preg_match("/\.js$/", $jsname);
  
  $locfnam = isset($_SERVER['HTTP_HOST']) ? $_SERVER['DOCUMENT_ROOT'] .'/'. $jsname : $jsname;
  if($xploit || !file_exists($locfnam)) {

    if($xploit) {
      //header('Status: 404 Not Found');
      header('HTTP/1.1 403 Forbidden');
      echo "xploit! $xploit";
    } else {
      header('HTTP/1.1 404 Not Found');
      echo $jsname;
    }
    exit;
  }
  #$JS = file_get_contents($locfnam);
  $pjs = new jsparser($locfnam, true);

  $ht = gettimeofday();
  $cid1 = 1000 * ($ht['sec'] + $ht['minuteswest']*60) + (int)($ht['usec']/1000);

  // init common dh-values
  global $dh_gs, $dh_ps2, $dh_qs2, $dh_ps3, $dh_ps4;
  if(isset($_COOKIE['dhpub'])) {
    list($g, $p) = explode('.', $_COOKIE['dhpub']);
    $dh_g = gmp_init($g);
    $dh_p = gmp_init($p);
  } else {
    $dh_g = gmp_init($dh_gs);
    $dh_p = gmp_init($dh_ps3);	// ps3 ~ 256 bit
  }

  // build dh - keys
  $dh_b = gmp_random(8);			// secret key bob
  $dh_bpub = gmp_powm($dh_g, $dh_b, $dh_p);	// public key bob
  $dh_apub = gmp_init($cid2, 62);		// public key alice
  $dh_ckey = gmp_powm($dh_apub, $dh_b, $dh_p);	// common key
  $asckey = gmp_strval($dh_ckey, 62);
  $asckey = substr($asckey, 0, 32);
  //$asckey = strtolower($asckey);		// only necessary for hex

  // pack file
  $json = json_encode($pjs->nplpack());
    
  // now encrypt it
  $cciph = MCRYPT_3DES;
  $cciph = MCRYPT_RIJNDAEL_256; 	// AES
  $cmode = MCRYPT_MODE_CBC;
  $ivs = mcrypt_get_iv_size($cciph, $cmode);
  $iv = mcrypt_create_iv($ivs, MCRYPT_DEV_URANDOM);
  $cipher = mcrypt_encrypt($cciph, $asckey, $json, $cmode, $iv);
  //echo mcrypt_decrypt($cciph, $asckey, $cipher, $cmode, $iv); exit;
  
  header('Content-Type: application/json');
  echo json_encode(array(
			 'cid1' => $cid1,
			 'cid2' => gmp_strval($dh_bpub, 62),
			 //'ckey' => gmp_strval($dh_ckey, 62),
			 'init' => base64_encode($iv),
			 'text' => base64_encode($cipher),
			 //'ctxt' => base64_encode($json),
			 ));
}

?>
